/**************************************************************************/
/*                                                                        */
/* Copyright (c) 2001, 2005 NoMachine, http://www.nomachine.com.          */
/*                                                                        */
/* NXUEXEC, NX protocol compression and NX extensions to this software    */
/* are copyright of NoMachine. Redistribution and use of the present      */
/* software is allowed according to terms specified in the file LICENSE   */
/* which comes in the source distribution.                                */
/*                                                                        */
/* Check http://www.nomachine.com/licensing.html for applicability.       */
/*                                                                        */
/* NX and NoMachine are trademarks of Medialogic S.p.A.                   */
/*                                                                        */
/* All rights reserved.                                                   */
/*                                                                        */
/**************************************************************************/


boolean scriptTextScript(const char *filename) {
  extern char **environ;
  FILE *pipefp;
  char command [255];
  char readbuf [255];
  char *results;

  if (filename == 0) return 1;
  
  if ((strlen(FILECOMMAND) + 1 + strlen(filename)) > MAX_LENGTH) {
    fprintf(stderr,"Error: Full path name too long: '%d'.\n",MAX_LENGTH);
    exit(1);
  } 
  
  strcpy(command,FILECOMMAND);
  strcat(command," ");
  strcat(command,filename);

  if (( pipefp = popen(command, "r")) == NULL) {
    fprintf(stderr,"Error: Cannot open pipe: Error is %d '%s'.\n",errno,strerror(errno));
    exit(1);
  }

  if (! fgets(readbuf, 254, pipefp)) {
    fprintf(stderr,"Error: Function fgets failed '%d': %s.\n",errno,strerror(errno));
    fprintf(stderr,"Error: Cannot check script type '%s'.\n",filename);
    exit(1);
  }

  if (pclose(pipefp) == -1) {
      fprintf(stderr,"Error: Function pclose failed '%d': '%s'.\n",errno,strerror(errno));
      fprintf(stderr,"Error: Cannot check script type '%s'.\n",filename);
      exit(1);
  }

  if (strcmp(readbuf,filename)==-1) {return false;}

  results=strstr(readbuf,"")+strlen(filename)+1;
  
  if (strstr(results," script")) {return true; }
    else {return false; }
}

