/**************************************************************************/
/*                                                                        */
/* Copyright (c) 2001, 2005 NoMachine, http://www.nomachine.com.          */
/*                                                                        */
/* NXUEXEC, NX protocol compression and NX extensions to this software    */
/* are copyright of NoMachine. Redistribution and use of the present      */
/* software is allowed according to terms specified in the file LICENSE   */
/* which comes in the source distribution.                                */
/*                                                                        */
/* Check http://www.nomachine.com/licensing.html for applicability.       */
/*                                                                        */
/* NX and NoMachine are trademarks of Medialogic S.p.A.                   */
/*                                                                        */
/* All rights reserved.                                                   */
/*                                                                        */
/**************************************************************************/


#define INC_SIZE 80

ssize_t nxgetline(char **bufferp,size_t *leng,FILE *f)
{
  size_t linelen, len=0;
  char *buffer;
  ssize_t rvalue = -1;
  int c;

  if (*bufferp) 
  {
    linelen = *leng;
    buffer = *bufferp;
  }
  else
  {
    buffer = malloc(INC_SIZE);
    linelen = INC_SIZE;
  }

  while (1)
  {
    c = fgetc(f);
    switch (c)
    {
    case '\n':
      buffer[len] = '\0';
      rvalue = len;
      goto finished;
    case EOF:
      buffer[len - 1] = '\0';
      if (feof(f)) rvalue = -1;
     /*   rvalue = len; */
      goto finished;
    default:
      break;
    }
    buffer[len++] = c;
    if (len == linelen - 1)
    {
      linelen += INC_SIZE;
      buffer = (char *)realloc(buffer, linelen);
    }
  }
finished:
  *bufferp = buffer;
  *leng = linelen;
  return rvalue;
}

